/* ---------------------------------------------------------------- */
//
// AcroIO.h
// Swope / ADC
//
// Created by Christoph Birk on 2014-05-19
//
/* ---------------------------------------------------------------- */

#import  "Tcpip.h"

#include "main.h"                      // SimulatorOnly flag

/* ---------------------------------------------------------------- */

#ifdef SIM_ONLY
#define ACRO_PORT    (0xffff-502)      // 502 is a privileged port
#else
#define ACRO_PORT    502
#endif

enum acro_errors_enum { E_acro_error=E_tcpip_error+400, // b0024
  E_acro_ioerror,
  E_acro_last
};

/* ---------------------------------------------------------------- */

@interface AcroIO : TCPIP_Connection {
}

+ (NSString*)errorString:(int)err;

- (int)getAnalog:(int)channel value:(int*)value;

- (int)setCoil:(int)channel status:(int)status;
- (int)getCoil:(int)channel status:(int*)status;
- (int)getInputs:(int*)value;

@end

/* ---------------------------------------------------------------- */
/* ---------------------------------------------------------------- */
/* ---------------------------------------------------------------- */
