/* ---------------------------------------------------------------- */
//
// AppDelegate.h
// ADC
//
// Created by Christoph Birk on 2017-10-17
// Copyright (c) 2017 Christoph Birk. All rights reserved.
//
/* ---------------------------------------------------------------- */

#import <Cocoa/Cocoa.h>

#import "ADC_Controller.h"
#import "Logger.h"

/* ---------------------------------------------------------------- */

extern char   *p_exec,*p_build,*p_version,*p_ident,*r_path,*s_path;
extern Logger *main_logger;
extern BOOL   use_shared;

/* ---------------------------------------------------------------- */

@interface AppDelegate : NSObject <NSApplicationDelegate>
{
  IBOutlet ADC_Controller *adcController;
  // GUI - Configuration
  IBOutlet NSWindow       *window_config;
  IBOutlet NSTextField    *edit_acroA,*edit_acroD,*edit_tcs;
  IBOutlet NSPopUpButton  *popup_acroA,*popup_acroD,*popup_tcs;
  // GUI - Preferences
  IBOutlet NSPanel        *panel_prefs;
  IBOutlet NSTextField    *edit_interval;
  IBOutlet NSButton       *chk_autostart;
  IBOutlet NSPopUpButton  *popup_mode; 
  IBOutlet NSImageView    *view_eng;
  // GUI - Calibration
  IBOutlet NSPanel        *panel_calibrate;
}

@property (assign,readonly) NSPanel *panel_calibrate;
@property (assign,readonly) int prism_mode;

- (void)goodbye:(NSString*)text error:(int)err;
- (void)updateRunMode;

@end

/* ---------------------------------------------------------------- */
/* ---------------------------------------------------------------- */
/* ---------------------------------------------------------------- */
