/*
 * how often do the ADC prisms move ?
 *
 */

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <time.h>
#include <math.h>
#include <assert.h>

extern char* strptime(const char*,const char*,struct tm*);

int main(int argc,char** argv)
{
  char buffer[1024];
  struct tm tp;
  int    i,ta1=0,ta2=0,dt,tb1=0,tb2=0,interval=30;
  double s1=0,s2=0,sn=0;
  int    hist[99];

  for (i=0; i<99; i++) hist[i]=0;
 
  if (argc > 1) interval = atoi(argv[1]);

  FILE *fp = fopen("/export/data1/birk/Clay/Guanaco/ADC/adc2019_24.log","r");
  if (fp) { 
    while (fgets(buffer,sizeof(buffer),fp) != NULL) {
      if (!strstr(buffer,"moveLens:to:")) continue;
      dt = 0;
      if (strstr(buffer,":](A,")) {
        if (!strptime(buffer,"%b %d %H:%M:%S",&tp)) continue;
        // printf("%02d %02d %02d %s",tp.tm_hour,tp.tm_min,tp.tm_sec,buffer);
        ta2 = 3600*tp.tm_hour + 60*tp.tm_min + tp.tm_sec;
        if ((ta1 > 0) &&  (ta2 > ta1)) dt = ta2-ta1;
        ta1 = ta2;
      } else
      if (strstr(buffer,":](B,")) {
        if (!strptime(buffer,"%b %d %H:%M:%S",&tp)) continue;
        // printf("%02d %02d %02d %s",tp.tm_hour,tp.tm_min,tp.tm_sec,buffer);
        tb2 = 3600*tp.tm_hour + 60*tp.tm_min + tp.tm_sec;
        if ((tb1 > 0) &&  (tb2 > tb1)) dt = tb2-tb1;
        tb1 = tb2;
      }
      if ((dt > 0) && (dt < 99*interval)) {
        hist[dt/interval] += 1;
        s1 += (double)dt; s2 += (double)(dt*dt); sn += 1;
      }
    }
    fclose(fp);
    double ave = s1/sn;
    double sig = sqrt(s2/sn-ave*ave);
    printf("%.1f %.2f\n",ave,sig);
    for (i=0; i<20; i++) {
      //if (hist[i] == 0) break;
      printf("%4d %4d (%.3f)\n",(i+1)*interval,hist[i],(double)hist[i]/sn);
    }
  }

  return 0;
}

