/*
 * histogram of "residuals" after ADC moves
 *
 */

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <time.h>
#include <math.h>
#include <assert.h>

// extern char* strptime(const char*,const char*,struct tm*);

int main(int argc,char** argv)
{
  char   buffer[1024];
  int    i,j,k,w,w1=22,w2=22,imax;
  double s1=0,s2=0,sn=0,interval=0.1,dt;
  int    hist[2][99];
  char   file[512],base[128],path[256]="/export/data1/birk/Clay",*p;
  char   *names[2]={"Guanaco","Zorro"};

  if (argc > 1) { w1 = w2 = atoi(argv[1]); } 
  if (argc > 2) { w2 = atoi(argv[2]); } 

  for (i=0; i<99; i++) {
    for (j=0; j<2; j++) hist[j][i]=0;
  }
 
  for (k=0; k<2; k++) {
    sprintf(base,"move%c",((k==0) ? 'A' : 'B'));
    s1 = s2 = sn = 0.0f;
    for (j=0; j<2; j++) {
      for (w=w1; w<=w2; w++) { 
        sprintf(file,"%s/%s/ADC/adc2019_%02d.log",path,names[j],w);
        printf("%s %s\n",base,file);
        FILE *fp = fopen(file,"r");
        if (!fp) continue;
        while (fgets(buffer,sizeof(buffer),fp) != NULL) {
          if (!strstr(buffer,base)) continue;
          p = strstr(buffer,"dist=");
          assert(p);
          dt = fabs(atof(p+5));
          if (dt < 99*interval) {
            hist[k][(int)(dt/interval)] += 1;  /* implicit floor() */
            s1 += (double)dt; s2 += (double)(dt*dt); sn += 1;
          }
        }
        fclose(fp);
      }
    }
    printf("%s\n",base);
    double ave = s1/sn;
    double sig = sqrt(s2/sn-ave*ave);
    printf("%.1f %.2f (%.0f)\n",ave,sig,sn);
    for (imax=99; imax>0; imax--) { if (hist[k][imax-1]) break; }
    for (i=0; i<imax; i++) {
      printf("%.1f  %4d  %.3f\n",(i+1)*interval,
             hist[k][i],(double)hist[k][i]/sn);
    }
  }

  return 0;
}

